string DV_HiCommand = "Hello everyone!";
string DV_HiUserCommand = "Hello {user}!";
string DV_BbCommand = "Goodbye everyone!";
string DV_BbUserCommand = "Goodbye {user}!";
string DV_GGCommand = "gga";
string DV_GGUserCommand = "gg {user}";
string DV_GLHFCommand = "glhf";
string DV_GRCommand = "gr";
string DV_GRUserCommand = "gr {user}";
string DV_AFKCommand = "AFK";
string DV_BackCommand = "Re";
string DV_RQCommand = "I rage quit!|I give up!|I can't stand this map anymore!|Duck this map!";

[Setting name="Hi command" category="Strings"]
string Setting_HiCommand = DV_HiCommand;

[Setting name="Hi {user} command" category="Strings" description="You can place the {user} tag everywhere."]
string Setting_HiUserCommand = DV_HiUserCommand;

[Setting name="Bb command" category="Strings"]
string Setting_BbCommand = DV_BbCommand;

[Setting name="Bb {user} command" category="Strings" description="You can place the {user} tag everywhere."]
string Setting_BbUserCommand = DV_BbUserCommand;

[Setting name="GG command" category="Strings"]
string Setting_GGCommand = DV_GGCommand;

[Setting name="GG {user} command" category="Strings" description="You can place the {user} tag everywhere."]
string Setting_GGUserCommand = DV_GGUserCommand;

[Setting name="GLHF command" category="Strings"]
string Setting_GLHFCommand = DV_GLHFCommand;

[Setting name="GR command" category="Strings"]
string Setting_GRCommand = DV_GRCommand;

[Setting name="GR {user} command" category="Strings" description="You can place the {user} tag everywhere."]
string Setting_GRUserCommand = DV_GRUserCommand;

[Setting name="AFK command" category="Strings"]
string Setting_AFKCommand = DV_AFKCommand;

[Setting name="Back/Re command" category="Strings"]
string Setting_BackCommand = DV_BackCommand;

[Setting name="RQ command" category="Strings"]
string Setting_RQCommand = DV_RQCommand;

class HiCmd : BetterChat::ICommand
{
	string Icon() { return Icons::HandPeaceO; }
	string Description() { return "Says Hi"; }

	void Run(const string &in text)
	{
		string param = GetParameter(text);
		if(param != ""){
			BetterChat::SendChatMessage(Replace("\\{user\\}", param, Setting_HiUserCommand));
		}else{
			BetterChat::SendChatMessage(Setting_HiCommand);
		}
	}
}

class BbCmd : BetterChat::ICommand
{
	string Icon() { return Icons::Kenney::Exit; }
	string Description() { return "Says Goodbye"; }

	void Run(const string &in text)
	{
		string param = GetParameter(text);
		if(param != ""){
			BetterChat::SendChatMessage(Replace("\\{user\\}", param, Setting_BbUserCommand));
		}else{
			BetterChat::SendChatMessage(Setting_BbCommand);
		}
	}
}

class GgCmd : BetterChat::ICommand
{
	string Icon() { return Icons::HandshakeO; }
	string Description() { return "Says GG"; }

	void Run(const string &in text)
	{
		string param = GetParameter(text);
		if(param != ""){
			BetterChat::SendChatMessage(Replace("\\{user\\}", param, Setting_GGUserCommand));
		}else{
			BetterChat::SendChatMessage(Setting_GGCommand);
		}
	}
}

class GlhfCmd : BetterChat::ICommand
{
	string Icon() { return Icons::Fire; }
	string Description() { return "Says GLHF"; }

	void Run(const string &in text)
	{
		BetterChat::SendChatMessage(Setting_GLHFCommand);
	}
}

class GrCmd : BetterChat::ICommand
{
	string Icon() { return Icons::HandshakeO; }
	string Description() { return "Says GR"; }

	void Run(const string &in text)
	{
		string param = GetParameter(text);
		if(param != ""){
			BetterChat::SendChatMessage(Replace("\\{user\\}", param, Setting_GRUserCommand));
		}else{
			BetterChat::SendChatMessage(Setting_GRCommand);
		}
	}
}

class RqCmd : BetterChat::ICommand
{
	string Icon() { return Icons::PowerOff; }
	string Description() { return "Rage quit"; }

	void Run(const string &in text)
	{
		bool onServer = !script_api.IsServerOrSolo;
		if(onServer == true && Setting_RQCommand != ""){
			auto RQlist = Setting_RQCommand.Split("|");
			int rdm = Math::Rand(0, RQlist.get_Length());
			
			BetterChat::SendChatMessage(RQlist[rdm]);
			
			script_api.QuitServer(false);
		}
	}
}

class AfkCmd : BetterChat::ICommand
{
	string Icon() { return "\\$f00" + Icons::PowerOff; }
	string Description() { return "Be AFK (Spectate)"; }

	void Run(const string &in text)
	{
		bool onServer = !script_api.IsServerOrSolo;
		if(onServer == true){
			BetterChat::SendChatMessage(Setting_AFKCommand);
			script_api.RequestSpectatorClient(true);
		}
	}
}

class BackCmd : BetterChat::ICommand
{
	string Icon() { return "\\$0f0" + Icons::PowerOff; }
	string Description() { return "Quit AFK"; }

	void Run(const string &in text)
	{
		bool onServer = !script_api.IsServerOrSolo;
		if(onServer == true){
			BetterChat::SendChatMessage(Setting_BackCommand);
			script_api.RequestSpectatorClient(false);
		}
	}
}

// TODO: Convert username to login
// class SpectateCmd : BetterChat::ICommand
// {
// 	string Icon() { return Icons::Eye; }
// 	string Description() { return "Spectate someone"; }

// 	void Run(const string &in text)
// 	{
// 		string param = GetParameter(text);
// 		bool onServer = !script_api.IsServerOrSolo;
// 		if(onServer == true && param != ""){
// 			BetterChat::SendChatMessage(Setting_BackCommand);
// 			script_api.RequestSpectatorClient(true);
// 			script_api.SetSpectateTarget(param);
// 		}
// 	}
// }

class SaveMapCmd : BetterChat::ICommand
{
	string Icon() { return Icons::Kenney::Save; }
	string Description() { return "Save map"; }

	void Run(const string &in text)
	{
		bool onServer = !script_api.IsServerOrSolo;
		if(onServer == true){
			script_api.SaveMap("Downloaded/"+StripFormatCodes(script_api.Map.MapName));
		}
	}
}

class VoteCmd : BetterChat::ICommand
{
	string Icon() { return Icons::CheckSquareO; }
	string Description() { return "Request a vote"; }

	void Run(const string &in text)
	{
		string param = GetParameter(text);
		bool onServer = !script_api.IsServerOrSolo;
		if(onServer == true && param != ""){
			if(param == "res" || param == "restart"){
				script_api.RequestRestartMap();
			}else if(param == "skip"){
				script_api.RequestNextMap();
			}else{
				UI::ShowNotification(Icons::ExclamationTriangle + " Error !", "Unknown parameter", UI::HSV(0, 0.5, 0.5));
			}
		}else{
			UI::ShowNotification(Icons::InfoCircle + " Information", "Available commands: skip, restart", UI::HSV(0.25, 0.5, 0.5));
		}
	}
}

CGamePlaygroundClientScriptAPI@ script_api;

void Main() {
	BetterChat::RegisterCommand("hi", HiCmd());
	BetterChat::RegisterCommand("bb", BbCmd());
	BetterChat::RegisterCommand("gg", GgCmd());
	BetterChat::RegisterCommand("glhf", GlhfCmd());
	BetterChat::RegisterCommand("gr", GrCmd());
	BetterChat::RegisterCommand("rq", RqCmd());
	BetterChat::RegisterCommand("afk", AfkCmd());
	BetterChat::RegisterCommand("back", BackCmd());
	BetterChat::RegisterCommand("re", BackCmd());
	BetterChat::RegisterCommand("savemap", SaveMapCmd());
	BetterChat::RegisterCommand("vote", VoteCmd());
	// BetterChat::RegisterCommand("spectate", SpectateCmd());
	// BetterChat::RegisterCommand("spec", SpectateCmd());
	
	@script_api = cast<CGamePlaygroundClientScriptAPI>(GetApp().Network.PlaygroundClientScriptAPI);
}

void OnDestroyed() {
	BetterChat::UnregisterCommand("hi");
	BetterChat::UnregisterCommand("bb");
	BetterChat::UnregisterCommand("gg");
	BetterChat::UnregisterCommand("glhf");
	BetterChat::UnregisterCommand("gr");
	BetterChat::UnregisterCommand("rq");
	BetterChat::UnregisterCommand("afk");
	BetterChat::UnregisterCommand("back");
	BetterChat::UnregisterCommand("re");
	BetterChat::UnregisterCommand("savemap");
	BetterChat::UnregisterCommand("vote");
}

string GetParameter(string text)
{
	auto params = text.Split(" ");
	if(params.get_Length() > 1){
		return params[1];
	}else{
		return "";
	}
}

string Replace(string search, string replace, string subject)
{
	return Regex::Replace(subject, search, replace);
}